include graphics.e
include image.e
include machine.e

tick_rate(400)

global procedure wait()
	atom tempo
	tempo=time()
	tempo=tempo+0.00015
	while time()<tempo do
	end while
end procedure

global procedure fade_left(sequence image)
	for y=1 to length(image[1]) do
		for x=1 to length(image) do
			pixel(image[x][y], {y,x})
		end for
	wait()
	end for
end procedure

global procedure fade_right(sequence image)
	for y=length(image[1]) to 1 by -1 do
		for x=1 to length(image) do
			pixel(image[x][y], {y,x})
		end for
	wait()
	end for
end procedure

global procedure fade_top(sequence image)
	for x=1 to length(image) do
		pixel(image[x],{0,x})
		wait()
	end for
end procedure

global procedure fade_bottom(sequence image)
	for x=length(image) to 1 by -1 do
		pixel(image[x],{0,x})
		wait()
	end for
end procedure

global function copy_image(atom x1, atom y1, atom x2, atom y2)
	atom x, a
	sequence imagem
	x=x2-x1
	a=1
	imagem=repeat(0,(y2-y1+1))
	for ad=1 to length(imagem) do
		imagem[ad]=repeat(0,x)
	end for
	for y=y1 to y2 do
		imagem[a]=get_pixel({x1,y,x})
		a=a+1
	end for
	return imagem
end function

global function copy_screen()
	sequence screen
	screen=copy_image(0,0,320,200)
	return screen
end function

global procedure reduce_screen(atom color)
	atom a,b,c,d
	a=0
	b=0
	c=320
	d=200
	for x=1 to 101 do
		polygon(color,0,{{a,b},{c,b},{c,d},{a,d},{a,b}})
		a=a+1
		b=b+1
		c=c-1
		d=d-1
		wait()
	end for
end procedure
